<template>
  <component
    is="a-modal"
    :width="tool.getDevice() === 'mobile' ? '100%' : '600px'"
    v-model:visible="visible"
    :title="title"
    :mask-closable="false"
    :ok-loading="loading"
    @cancel="close"
    @before-ok="submit">
    <!-- 表单信息 start -->
    <a-form ref="formRef" :model="formData" :rules="rules" :auto-label-width="true">
      <a-form-item label="包名" field="package_name">
        <a-input v-model="formData.package_name" placeholder="请输入包名" />
      </a-form-item>
      <a-form-item label="咨询允许获得权限" field="qx">
        <sa-switch v-model="formData.qx" checkedText="开启" uncheckedText="关闭" />
      </a-form-item>
      <a-form-item label="隐私弹窗" field="ystc">
        <sa-switch v-model="formData.ystc" checkedText="开启" uncheckedText="关闭" />
      </a-form-item>
      <a-form-item label="登录框同意勾选文案" field="init">
        <sa-switch v-model="formData.init" checkedText="开启" uncheckedText="关闭" />
      </a-form-item>
    </a-form>
    <!-- 表单信息 end -->
  </component>
</template>

<script setup>
import { ref, reactive, computed } from 'vue'
import tool from '@/utils/tool'
import { Message, Modal } from '@arco-design/web-vue'
import api from '../../api/center/qxSwitch'

const emit = defineEmits(['success'])
// 引用定义
const visible = ref(false)
const loading = ref(false)
const formRef = ref()
const mode = ref('')

let title = computed(() => {
  return '权限开关' + (mode.value == 'add' ? '-新增' : '-编辑')
})

// 表单初始值
const initialFormData = {
  id: null,
  package_name: '',
  qx: 1,
  ystc: 1,
  init: 1,
}

// 表单信息
const formData = reactive({ ...initialFormData })

// 验证规则
const rules = {
  package_name: [{ required: true, message: '包名必需填写' }],
  qx: [{ required: true, message: '咨询允许获得权限必需填写' }],
  ystc: [{ required: true, message: '隐私弹窗必需填写' }],
  init: [{ required: true, message: '登录框同意勾选文案必需填写' }],
}

// 打开弹框
const open = async (type = 'add') => {
  mode.value = type
  // 重置表单数据
  Object.assign(formData, initialFormData)
  formRef.value.clearValidate()
  visible.value = true
  await initPage()
}

// 初始化页面数据
const initPage = async () => {}

// 设置数据
const setFormData = async (data) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      formData[key] = data[key]
    }
  }
}

// 数据保存
const submit = async (done) => {
  const validate = await formRef.value?.validate()
  if (!validate) {
    loading.value = true
    let data = { ...formData }
    let result = {}
    if (mode.value === 'add') {
      // 添加数据
      data.id = undefined
      result = await api.save(data)
    } else {
      // 修改数据
      result = await api.update(data.id, data)
    }
    if (result.code === 200) {
      Message.success('操作成功')
      emit('success')
      done(true)
    }
    // 防止连续点击提交
    setTimeout(() => {
      loading.value = false
    }, 500)
  }
  done(false)
}

// 关闭弹窗
const close = () => (visible.value = false)

defineExpose({ open, setFormData })
</script>
